' -- LOWCASE.BAS --
' 1985 Hileman Software
' William D. Hileman
'
' Initialize
'
defint a-z
on error goto trapper
false=0
true=not false
'
' Display title
'
print "ͻ"
print " LOWCASE - Convert upper to lower case. "
print "Ȼ (C)opyright 1985 by Hileman Software ɼ"
print " ͻ Version 1.00 - August 14, 1985 ͼ"
print "    ͼ"
print
'
' Get source filename
'
if command$="" then _
  line input "Enter Source Filename: ";src.name$: _
  print: _
else _
  if command$="?" then _
    gosub help: _
    goto done _
  else _
    src.name$=command$
  rem endif
rem endif
if src.name$="" then _
  goto done
rem endif
gosub check.filename
if name.err then _
  beep: _
  print "Invalid filename: '";src.name$;"'";: _
  goto done
rem endif
'
' Make destination filename
'
x=instr(src.name$,".")
if x=0 then _
  dest.name$=src.name$+".LOC" _
else _
  dest.name$=left$(src.name$,x-1)+".LOC"
rem endif
'
' Main routine
'
open.src:
  open "I",1,src.name$
open.dst:
  open "O",2,dest.name$
end.chk.1:
'
print "Creating File: '";dest.name$;"'";
'
while not eof(1)
  read.src:
    line input #1,s$
  end.chk.2:
  for x=1 to len(s$)
    ss$=mid$(s$,x,1)
    if ss$>="A" and ss$<="Z" then _
      ss$=chr$(asc(ss$) or 32)
      mid$(s$,x,1)=ss$
    rem endif
  next x
  write.dest:
    print #2,s$
  end.chk.3:
wend
'
done:
'
close
end
'
' Subroutines
'
' Display help message (command line syntax)
'
help:
'
print "ͻ"
print " LOWCASE  is a utility which reads an ASCII file and creates a  file "
print " with  the  same filename and the extension '.LOC'.  This  new  file "
print " has  lower-case  letters ('a'-'z') in place  of  upper-case letters "
print " ('A'-'Z').  All other characters remain unchanged.                  "
print "͹"
print " LOWCASE accepts the following syntax:                               "
print "͹"
print "         LOWCASE ?              - displays this message              "
print "         LOWCASE filename[.ext] - creates filename.LOC               "
print "         LOWCASE                - prompts for source filename        "
print "ͼ"
'
return
'
' Check filename for minimum constraints
' Only checks for the following types:
'     '\xxxxxx\xxxxxxxx.xxxx' (more than 3-char extension)
'                      '.xxx' (period is first char)
' This is to allow the software to create a destination filename.
' The source filename will be checked as it is opened.
'
'
check.filename:
'
name.err=false
pp=instr(src.name$,".")
if pp<>0 then _
  if pp<(len(src.name$)-3) then _
    name.err=true _
  else if pp=1 then _
    name.err=true
  rem endif
rem endif
'
return
'
' Error routines
'
trapper:
'
beep
if erl=open.src then _
  print "Source file '";src.name$;"' not found!";: _
  resume done _
else if erl=open.dst then _
  print "Error on open of destination file '";dest.name$;"'": _
  print "Error code:";err;: _
  resume done _
else if erl=read.src then _
  print "Error on read of source file '";src.name$;"'";: _
  print "Error code:";err;: _
  resume done _
else if erl=read.dst then _
  print "Error on read of destination file '";dest.name$;"'";: _
  print "Error code:";err;: _
  resume done
rem endif
'
on error goto 0
'
' End of code
'
